Subject: [Ioam] suggestion to IOAM charter

From: Haoyu song <[email-masked]>
Date: Thu, 2 Feb 2017 02:13:00 +0000

I like the idea of in-situ OAM and believe it has unique advantages to address many network OAM problems.
We all agree today's hardware can do a lot more things than before and the software-based network device is very flexible and becomes more popular. Hence, I suggest to slightly extend the scope of in-situ OAM to take advantage of this and make the telemetry smarter by including a little bit in-network programming and computing capability. I have talked about some related ideas in dynamic network probe (https://datatracker.ietf.org/doc/slides-97-sdnrg-33-dynamic-network-probes-on-programmable-data-plane/) and believe some of these ideas can be applied in in-situ OAM.
For example, instead of asking each node to timestamp the packet, why don't simply ask the data plane to directly report the path latency which is calculated by the timestamp at the path head and the packet arrival time at the path end. The packets only need to carry the timestamp of the first node on the path. After all, the path latency is the actual information that the network operator is interested in. Even better, we can tell the data plane to report an event only when the path latency exceeds some predefined threshold, because in many case, the operator doesn't want to be flooded by normal telemetry data and only care about anomalies.  When the data plane is responsible for doing such simple processing, it reduces the amount of raw data and the network operator's work load, and allows faster reaction to network states.
This would require the ability to dynamically install "programmable" probes in to data plane and require the packet format to be flexible enough to carry custom data. While not all data plane devices can support this immediately, this can significantly expand the flexibility and applicability of the in-situ OAM, so these use cases are better to be considered and covered now rather than later.
Any comments and suggestions?
Thanks!
-Haoyu